
package de.ivu.elect.presentation.benutzerverwaltung.exchange;

import java.util.List;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.benutzerverwaltung.boundary.BenutzerImporter;
import de.ivu.elect.business.benutzerverwaltung.control.BenutzerExchangeContext;
import de.ivu.elect.business.benutzerverwaltung.entity.Benutzer;
import de.ivu.elect.business.exchange.control.AbstractImporter;
import de.ivu.elect.business.konfiguration.entity.KonfigurationLoader;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.entity.PasswordStoreType;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.exchange.AbstractImportBestaetigenView;
import de.ivu.elect.presentation.exchange.ImportDescription;

import static de.ivu.elect.business.konfiguration.entity.MandantKonfigurationWerte.LOGIN_SERVICE_PASSWORD_STORE_TYPE;

@Named(BenutzerImportBestaetigenView.COMPONENT_NAME)
@View(viewId = BenutzerImportBestaetigenView.VIEW_ID, useCase = UseCasePermission.BENUTZER_IMPORTIEREN)
public class BenutzerImportBestaetigenView
    extends
      AbstractImportBestaetigenView<List<Benutzer>, BenutzerExchangeContext> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "benutzerImportBestaetigenView";

  public static final String VIEW_ID = "/benutzerverwaltung/benutzer-import-bestaetigen.xhtml";

  @Inject
  private transient BenutzerImporter benutzerImporter;

  @Inject
  private transient BenutzerImportDescription benutzerImportDescription;

  @Inject
  private transient KonfigurationLoader konfigurationLoader;

  private BenutzerExchangeContext context;

  public BenutzerImportBestaetigenView() {
    super();
  }

  @Override
  protected AbstractImporter<List<Benutzer>, BenutzerExchangeContext, ? > getImporter() {
    return benutzerImporter;
  }

  @Override
  protected BenutzerExchangeContext getContext() {
    if (context == null) {
      context = new BenutzerExchangeContext(getMandant(), getBenutzer(), isPasswortImKlartextErlaubt(), false);
    }
    return context;
  }

  private boolean isPasswortImKlartextErlaubt() {
    return konfigurationLoader.resolveEnumValue(getMandant(), LOGIN_SERVICE_PASSWORD_STORE_TYPE, PasswordStoreType.class).isKlartextUnterstuetzt();
  }

  @Override
  protected ImportDescription getImportDescription() {
    return benutzerImportDescription;
  }

  public boolean isPasswortwechselErzwingen() {
    return getContext().isPasswortwechselErzwingen();
  }

  public void setPasswortwechselErzwingen(boolean passwortwechselErzwingen) {
    getContext().setPasswortwechselErzwingen(passwortwechselErzwingen);
  }
}
